local L = AceLibrary("AceLocale-2.2"):new("KingOfTheJungle")

local KOTJUIMAINFRAME = nil
local KOTJUITABS = {L["Options"],L["Foods"],L["Diets"]}
local KOTJUITABOPTIONFRAME = nil
local KOTJUITABFOODFRAME = nil
local KOTJUITABDIETFRAME = nil

function KingOfTheJungle:KOTJUI_Show()
	if not KOTJUIMAINFRAME then
		KOTJUIMAINFRAME = self:KOTJUI_CreateFrame()
		self:KOTJUI_CreateTabs()
	end
	
	if not KOTJUITABOPTIONFRAME then
		KOTJUITABOPTIONFRAME = self:KOTJUI_CreateOptions(KOTJUIMAINFRAME,384,512)		
	end
	
	if not KOTJUITABFOODFRAME then
		KOTJUITABFOODFRAME = self:KOTJUI_CreateFoodLists(KOTJUIMAINFRAME,384,512)		
	end
	
	if not KOTJUITABDIETFRAME then
		KOTJUITABDIETFRAME = self:KOTJUI_CreateDiets(KOTJUIMAINFRAME,384,512)		
	end
	
	PanelTemplates_SetNumTabs(KOTJUIMAINFRAME, #KOTJUITABS)
	KOTJUIMAINFRAME.selectedTab = 1
	PanelTemplates_UpdateTabs(KOTJUIMAINFRAME)

	KOTJUIMAINFRAME:Show()
	KOTJUITABOPTIONFRAME:Show()
	KOTJUITABFOODFRAME:Hide()
	KOTJUITABDIETFRAME:Hide()
end

function KingOfTheJungle:KOTJUI_HandlerTabButton(buttonname)
	button = getglobal(buttonname)
	KOTJUITABOPTIONFRAME:Hide()
	KOTJUITABDIETFRAME:Hide()
	KOTJUITABFOODFRAME:Hide()
	
	if button:GetText() == L["Options"] then
		KOTJUITABOPTIONFRAME:Show()
	elseif button:GetText() == L["Foods"] then
		KOTJUITABFOODFRAME:Show()
	elseif button:GetText() == L["Diets"] then
		KOTJUITABDIETFRAME:Show()
	end
end

function KingOfTheJungle:KOTJUI_CreateTabs()
	local x = 20
	local padding = 24
	for i,v in pairs(KOTJUITABS) do
		local b = CreateFrame("Button",KOTJUIMAINFRAME:GetName().."Tab"..i,KOTJUIMAINFRAME,"CharacterFrameTabButtonTemplate")
		b:SetID(i)
		b:SetText(v)
		PanelTemplates_TabResize(0, b)
	
		b:SetScript("OnClick", function() 
			PanelTemplates_Tab_OnClick(KOTJUIMAINFRAME)
			self:KOTJUI_HandlerTabButton(this:GetName())
		end )
		
		b:SetPoint("BOTTOMLEFT",x,45)
		x = x + b:GetTextWidth() + padding
	end	
end

function KingOfTheJungle:KOTJUI_CreateFrame()  	
	local f = CreateFrame("Frame","KOTJUIMainFrame",UIParent)
	f:SetFrameStrata("BACKGROUND")	
	f:SetWidth(384)  
	f:SetHeight(512) 
	f:SetHitRectInsets(0,30,0,45)
	f:SetPoint("CENTER",0,0)
	f:SetClampedToScreen(true)
	f:SetMovable(true)	
	f:EnableMouse(true)
    f:RegisterForDrag("LeftButton")	
	
--~ BACKGROUND TEXTURES	
--~ Portrait
	local portrait = f:CreateTexture(nil, "BACKGROUND")
	portrait:SetWidth(60)
	portrait:SetHeight(60)	
	portrait:SetPoint("TOPLEFT", f,"TOPLEFT",7,-6)

--~ BORDER TEXTURES
	local t = f:CreateTexture(nil, "BORDER")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-TopLeft.blp")
	t:SetWidth(256)	
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",2,-1)	
	
	t = f:CreateTexture(nil, "BORDER")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-TopRight.blp")
	t:SetWidth(128)
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",258,-1)	
	
	t = f:CreateTexture(nil, "BORDER")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-BottomLeft.blp")
	t:SetWidth(256)
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",2,-257)	
	
	t = f:CreateTexture(nil, "BORDER")	
	t:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-BottomRight.blp")
	t:SetWidth(128)
	t:SetHeight(256)
	t:SetPoint("TOPLEFT", f,"TOPLEFT",258,-257)	

--~ ARTWORK TEXTURES
	t = f:CreateTexture(nil, "ARTWORK")	
	t:SetTexture("Interface\\TalentFrame\\HunterBeastMastery-TopLeft.blp")
	t:SetWidth(256)
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",23,-77)	
	
	t = f:CreateTexture(nil, "ARTWORK")	
	t:SetTexture("Interface\\TalentFrame\\HunterBeastMastery-TopRight.blp")
	t:SetWidth(64)
	t:SetHeight(256)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",279,-77)	
	
	t = f:CreateTexture(nil, "ARTWORK")	
	t:SetTexture("Interface\\TalentFrame\\HunterBeastMastery-BottomLeft.blp")
	t:SetWidth(256)
	t:SetHeight(128)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",23,-333)	
	
	t = f:CreateTexture(nil, "ARTWORK")	
	t:SetTexture("Interface\\TalentFrame\\HunterBeastMastery-BottomRight.blp")
	t:SetWidth(64)
	t:SetHeight(128)	
	t:SetPoint("TOPLEFT", f,"TOPLEFT",279,-333)	

--~ FONTS
	local font = f:CreateFontString(nil, "ARTWORK", "GameFontNormal")
 	font:SetPoint("TOP", f,"TOP",0,-20)	
	font:SetText(L["King of the Jungle"])	

--~ BUTTONS
	local b = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	b:SetPoint("CENTER", f, "TOPRIGHT", -44, -25)
	
	b:SetScript("OnClick", function() 
		f:Hide()
	end )
	
--~ EVENT HANDLERS	
	f:SetScript("OnDragStart", function()
		this:StartMoving()		
	end)
	f:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()		
	end)
	f:SetScript("OnUpdate", function()
		if UnitExists("pet") then
			SetPortraitTexture(portrait,"pet")
		else
			portrait:SetTexture("Interface\\CharacterFrame\\TemporaryPortrait-Monster.blp")
		end
	end)	
	
	return f	
end