local L = AceLibrary("AceLocale-2.2"):new("KingOfTheJungle")

function KingOfTheJungle:KOTJUI_CreateDiets(parent, width, height)
--~ PARENT FRAME
	local f = CreateFrame("Frame","KingOfTheJungleUI_Diets_Frame",parent)
	f:SetPoint("TOPLEFT",28,-78) f:SetWidth(width) f:SetHeight(height) 	
	f:SetScript("OnShow",function() 
		KOTJUI_Diets_ScrollFrame_Update()
	end)
--~ SCROLL FRAME
	local sf = CreateFrame("ScrollFrame","KingOfTheJungleUI_Diets_ScrollFrame",f,"FauxScrollFrameTemplate")	
	sf:SetPoint("TOPLEFT",0,0) sf:SetWidth(width-28-65) sf:SetHeight(height-80-80) 		
	sf:SetScript("OnVerticalScroll",function() 
		return FauxScrollFrame_OnVerticalScroll(48,KOTJUI_Diets_ScrollFrame_Update)
	end)
--~ ITEM BUTTONS	
	for i = 1,7 do
--~ 	PARENT FRAME
		local fsub = CreateFrame("Frame",nil,f)
		fsub:SetWidth(305)  fsub:SetHeight(48) 
		fsub:SetPoint("TOPLEFT",f,"TOPLEFT",0,(i-1)*-48)
--~ 	TEXT STRINGS
		local s = fsub:CreateFontString("KOTJDietButton"..i.."Text", "ARTWORK", "GameFontNormal")	
		s:SetPoint("LEFT", 50, 0)		
		s:SetTextColor(1, 0.8, 0)
--~ 	BUTTONS
		local cb = CreateFrame("CheckButton","KOTJDietButton"..i.."Button",f)	
		cb:SetWidth(37)  cb:SetHeight(37) 
		cb:SetPoint("TOPLEFT",f,"TOPLEFT",4,((i-1)*-48)-3)
		cb:RegisterForClicks("LeftButtonUp", "RightButtonUp")

		cb:SetScript("OnClick", function()
			if IsControlKeyDown() then
				for i,_ in pairs(self.db.profile.foodlist) do									
					if self.db.profile.foodlist[i]["diet"] == L:GetReverseTranslation(cb.diet) then	
						if (i == 1 and arg1 == "LeftButton") or (i == #self.db.profile.foodlist and arg1 == "RightButton") then
							return
						end
						
						local tmp = {}
						tmp["diet"] = self.db.profile.foodlist[i]["diet"]
						tmp["list"] = self.db.profile.foodlist[i]["list"]
						
						if arg1 == "LeftButton" then
							self.db.profile.foodlist[i]["diet"] = self.db.profile.foodlist[i-1]["diet"]
							self.db.profile.foodlist[i]["list"] = self.db.profile.foodlist[i-1]["list"]
							self.db.profile.foodlist[i-1]["diet"] = tmp["diet"]
							self.db.profile.foodlist[i-1]["list"] = tmp["list"]							
						end
						if arg1 == "RightButton" then
							self.db.profile.foodlist[i]["diet"] = self.db.profile.foodlist[i+1]["diet"]
							self.db.profile.foodlist[i]["list"] = self.db.profile.foodlist[i+1]["list"]
							self.db.profile.foodlist[i+1]["diet"] = tmp["diet"]
							self.db.profile.foodlist[i+1]["list"] = tmp["list"]	
						end
						
						KOTJUI_Diets_ScrollFrame_Update()
					end
				end
			end						
		end)	

--~ 	TEXTURES
		local t2 = fsub:CreateTexture(nil, "BACKGROUND")	
		t2:SetTexture("Interface\\MailFrame\\MailItemBorder")
		t2:SetWidth(237) t2:SetHeight(48)
		t2:SetTexCoord(0.1640625,1.0,0,0.75)	
		t2:SetPoint("TOPLEFT",48,0)
		
		local t3 = cb:CreateTexture(nil, "BACKGROUND")	
		t3:SetTexture("Interface\\Buttons\\UI-EmptySlot-White")
		t3:SetWidth(64) t3:SetHeight(64)
		t3:SetPoint("CENTER")
		
		local t4 = cb:CreateTexture("KOTJDietButton"..i.."Icon", "ARTWORK")	
		t4:SetAllPoints(cb)
	end
	
	return f
end

function KOTJUI_Diets_ScrollFrame_Update()
	local offset
	local foodlist = KingOfTheJungle.db.profile.foodlist
	local frame = getglobal("KingOfTheJungleUI_Diets_ScrollFrame")
	
	FauxScrollFrame_Update(frame,#foodlist,7,48) 
		
	for i = 1,7 do
		offset = i + FauxScrollFrame_GetOffset(frame)	
		local icon = getglobal("KOTJDietButton"..i.."Icon")
		local button = getglobal("KOTJDietButton"..i.."Button")
		local text = getglobal("KOTJDietButton"..i.."Text")	
		
		if offset <= #foodlist then			
			button.diet = L[foodlist[offset]["diet"]]
--~ 			button.tooltip = itemLink
			text:SetText(button.diet)	
			icon:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark")			
		else
			button.diet = nil
			button.tooltip = nil
			text:SetText("")
			icon:SetTexture()
		end
	end	
end