local L = AceLibrary("AceLocale-2.2"):new("KingOfTheJungle")

function KingOfTheJungle:KOTJUI_CreateFoodLists(parent, width, height)
--~ PARENT FRAME
	local f = CreateFrame("Frame","KingOfTheJungleUI_Food_Frame",parent)
	f:SetPoint("TOPLEFT",28,-78) f:SetWidth(width) f:SetHeight(height) 	
	f:SetScript("OnShow",function() 
		KOTJUI_Foods_ScrollFrame_Update()
	end)
--~ DROPDOWN MENU	
	local ddb = CreateFrame("Frame","KOTJFoodButtonDropDown",f,"UIDropDownMenuTemplate")
	ddb:SetPoint("TOP",-20,30) 	
	ddb:SetScript("OnLoad", function()
		UIDropDownMenu_SetWidth(200,this)
		UIDropDownMenu_Initialize(this, KOTJUI_Foods_DropDownMenu_OnLoad)
		UIDropDownMenu_SetSelectedID(KOTJFoodButtonDropDown, 1)
	end)
	ddb:SetScript("OnShow", function()	
		UIDropDownMenu_SetWidth(200,this)
		UIDropDownMenu_Initialize(this, KOTJUI_Foods_DropDownMenu_OnLoad)
		UIDropDownMenu_SetSelectedID(KOTJFoodButtonDropDown, 1)		
	end)
--~ SCROLL FRAME
	local sf = CreateFrame("ScrollFrame","KingOfTheJungleUI_ScrollFrame",f,"FauxScrollFrameTemplate")	
	sf:SetPoint("TOPLEFT",0,0) sf:SetWidth(width-28-65) sf:SetHeight(height-80-80) 		
	sf:SetScript("OnVerticalScroll",function() 
		return FauxScrollFrame_OnVerticalScroll(48,KOTJUI_Foods_ScrollFrame_Update)
	end)
--~ ITEM BUTTONS	
	for i = 1,7 do
--~ 	PARENT FRAME
		local fsub = CreateFrame("Frame",nil,f)
		fsub:SetWidth(305)  fsub:SetHeight(48) 
		fsub:SetPoint("TOPLEFT",f,"TOPLEFT",0,(i-1)*-48)
--~ 	TEXT STRINGS
		local s = fsub:CreateFontString("KOTJFoodButton"..i.."Text", "ARTWORK", "GameFontNormal")	
		s:SetPoint("LEFT", 50, 0)		
		s:SetTextColor(1, 0.8, 0)
--~ 	BUTTONS
		local cb = CreateFrame("CheckButton","KOTJFoodButton"..i.."Button",f)	
		cb:SetWidth(37)  cb:SetHeight(37) 
		cb:SetPoint("TOPLEFT",f,"TOPLEFT",4,((i-1)*-48)-3)
		cb:RegisterForClicks("LeftButtonUp", "RightButtonUp")
		
		cb:SetScript("OnEnter", function()
			if ( this.tooltip ) then
				GameTooltip:SetOwner(this,"ANCHOR_RIGHT")
				GameTooltip:SetHyperlink(this.tooltip)
				GameTooltip:Show();
			end			
		end)
		cb:SetScript("OnLeave", function()
			GameTooltip:Hide()		
		end)
		cb:SetScript("OnClick", function()
			if getglobal("DropDownList1Button"..UIDropDownMenu_GetSelectedID(KOTJFoodButtonDropDown)):GetText() == "" then
				return
			end
			
			local foodlist = {}
			for i,_ in ipairs(self.db.profile.foodlist) do
				if self.db.profile.foodlist[i]["diet"] == L:GetReverseTranslation(getglobal("DropDownList1Button"..UIDropDownMenu_GetSelectedID(KOTJFoodButtonDropDown)):GetText()) then
					foodlist = self.db.profile.foodlist[i]["list"]
				end
			end

			if IsControlKeyDown() then
				for i,_ in pairs(foodlist) do				
					if foodlist[i]["id"] == cb.itemid then	
						if (i == 1 and arg1 == "LeftButton") or (i == #foodlist and arg1 == "RightButton") then
							return
						end
						
						local tmpfood = {}
						tmpfood["id"] = foodlist[i]["id"]
						tmpfood["value"] = foodlist[i]["value"]
						tmpfood["selected"] = foodlist[i]["selected"]
						
						if arg1 == "LeftButton" then
							foodlist[i]["id"] = foodlist[i-1]["id"]
							foodlist[i]["value"] = foodlist[i-1]["value"]
							foodlist[i]["selected"] = foodlist[i-1]["selected"]
							foodlist[i-1]["id"] = tmpfood["id"]
							foodlist[i-1]["value"] = tmpfood["value"]
							foodlist[i-1]["selected"] = tmpfood["selected"]
						end
						if arg1 == "RightButton" then
							foodlist[i]["id"] = foodlist[i+1]["id"]
							foodlist[i]["value"] = foodlist[i+1]["value"]
							foodlist[i]["selected"] = foodlist[i+1]["selected"]
							foodlist[i+1]["id"] = tmpfood["id"]
							foodlist[i+1]["value"] = tmpfood["value"]
							foodlist[i+1]["selected"] = tmpfood["selected"]
						end
						
						KOTJUI_Foods_ScrollFrame_Update()
					end
				end
			else	
				for i,_ in pairs(foodlist) do
					if foodlist[i]["id"] == cb.itemid then
						foodlist[i]["selected"] = not foodlist[i]["selected"]
						button.checked = foodlist[i]["selected"]
						if button.checked then
							s:SetTextColor(1, 0.8, 0)						
						else
							s:SetTextColor(1, 0, 0)
						end
					end
				end
			end						
		end)	

--~ 	TEXTURES
		local t2 = fsub:CreateTexture(nil, "BACKGROUND")	
		t2:SetTexture("Interface\\MailFrame\\MailItemBorder")
		t2:SetWidth(237) t2:SetHeight(48)
		t2:SetTexCoord(0.1640625,1.0,0,0.75)	
		t2:SetPoint("TOPLEFT",48,0)
		
		local t3 = cb:CreateTexture(nil, "BACKGROUND")	
		t3:SetTexture("Interface\\Buttons\\UI-EmptySlot-White")
		t3:SetWidth(64) t3:SetHeight(64)
		t3:SetPoint("CENTER")
		
		local t4 = cb:CreateTexture("KOTJFoodButton"..i.."Icon", "ARTWORK")	
		t4:SetAllPoints(cb)
	end
	
	return f
end

function KOTJUI_Foods_DropDownMenu_OnLoad() 
	for i,_ in ipairs(KingOfTheJungle.db.profile.foodlist) do
		info            = UIDropDownMenu_CreateInfo()
		info.text       = L[KingOfTheJungle.db.profile.foodlist[i]["diet"]]
		info.func       = KOTJUI_Foods_DropDownMenu_OnClick
		info.checked    = nil
		UIDropDownMenu_AddButton(info)
	end
end

function KOTJUI_Foods_DropDownMenu_OnClick() 
	UIDropDownMenu_SetSelectedID(KOTJFoodButtonDropDown,this:GetID())
	KOTJUI_Foods_ScrollFrame_Update()
end

function KOTJUI_Foods_ScrollFrame_Update()
	local offset
	
	local foodlist = {}
	for i,_ in ipairs(KingOfTheJungle.db.profile.foodlist) do
		if KingOfTheJungle.db.profile.foodlist[i]["diet"] == L:GetReverseTranslation(getglobal("DropDownList1Button"..UIDropDownMenu_GetSelectedID(KOTJFoodButtonDropDown)):GetText()) then
			foodlist = KingOfTheJungle.db.profile.foodlist[i]["list"]
			break
		end
	end
	
	local frame = getglobal("KingOfTheJungleUI_ScrollFrame")
	
	FauxScrollFrame_Update(frame,#foodlist,7,48) 
		
	for i = 1,7 do
		offset = i + FauxScrollFrame_GetOffset(frame)	
		local icon = getglobal("KOTJFoodButton"..i.."Icon")
		local button = getglobal("KOTJFoodButton"..i.."Button")
		local text = getglobal("KOTJFoodButton"..i.."Text")	
		if offset <= #foodlist then
			local itemName, itemLink, _, _, _, _, _, _, _, invTexture = GetItemInfo(foodlist[offset]["id"])
			button.itemid = foodlist[offset]["id"]
			button.tooltip = itemLink
			button.checked = foodlist[offset]["selected"]
			if button.checked then
				text:SetTextColor(1, 0.8, 0)				
			else
				text:SetTextColor(1, 0, 0)
			end
			if itemLink then	
				text:SetText(itemName)
				icon:SetTexture(invTexture)								
			else		
				if foodlist[offset]["id"] then
					text:SetText(L["Unknown Item ID"].." : "..foodlist[offset]["id"])	
					icon:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark")													
				else
					text:SetText("")
					icon:SetTexture()
				end
			end
		else
			button.itemid = nil
			button.tooltip = nil
			text:SetText("")
			icon:SetTexture()
		end
	end	
end